.\" Automatically generated by Pandoc 2.19.2
.\"
.\" Define V font for inline verbatim, using C font in formats
.\" that render this, and otherwise B font.
.ie "\f[CB]x\f[]"x" \{\
. ftr V B
. ftr VI BI
. ftr VB B
. ftr VBI BI
.\}
.el \{\
. ftr V CR
. ftr VI CI
. ftr VB CB
. ftr VBI CBI
.\}
.TH "QR-BACKUP" "1" "October 2022" "qr-backup 1.1.1" ""
.hy
.SH NAME
.PP
qr-backup - back up file(s) to a series of QR codes on paper
.SH SYNOPSIS
.PP
\f[B]qr-backup\f[R] [\f[I]OPTIONS\f[R]] \f[I]FILE\f[R]
[\f[I]FILE\f[R]\&...]
.PD 0
.P
.PD
\f[B]qr-backup\f[R] --restore [\f[I]OPTIONS\f[R]]
.PD 0
.P
.PD
\f[B]qr-backup\f[R] --restore [\f[I]OPTIONS\f[R]] \f[I]IMAGE\f[R]
[\f[I]IMAGE\f[R]\&...]
.SH DESCRIPTION
.PP
\f[B]qr-backup\f[R] converts a binary file to a backup suitable for
printing.
The backup is a .pdf file containing several barcodes.
.PP
\f[B]qr-backup --restore\f[R] restores a paper backup and outputs the
original file.
Restore is done using a webcam or scanner.
.PP
Restore is possible without \f[B]qr-backup\f[R].
Restore directions are included in the paper backup.
.SH OPTIONS
.TP
\f[B]--help\f[R], \f[B]-h\f[R]
Print a help message.
.TP
\f[B]--verbose\f[R], \f[B]-v\f[R]
Print more detailed information during run.
.TP
\f[B]--version\f[R], \f[B]-V\f[R]
Print the verison and immediately exit.
.SH BACKUP OPTIONS
.TP
\f[B]--compress\f[R], \f[B]--no-compress\f[R]
This gives a more compact backup, but partial recovery is impossible.
Default: compressed
.TP
\f[B]--dpi \f[BI]DPI\f[B]\f[R]
Sets the print resolution of your printer.
Default: 300
.TP
\f[B]--encrypt \f[BI]generate\f[B]\f[R], \f[B]--encrypt \f[BI]PASSPHRASE\f[B]\f[R]
Password-protect the backup.
If the passphrase is `generate', a passphrase is automatically generated
for you, which you would need to store securely or you will be unable to
unlock the data.
Default: disabled
.TP
\f[B]--encrypt-print-passphrase\f[R], \f[B]--no-encrypt-print-passphrase\f[R]
Print the passphrase on a sheet by itself.
Default: print if generated by qr-code, don\[cq]t print if passed in
.TP
\f[B]--erasure-coding\f[R], \f[B]--no-erasure-coding\f[R]
This allows restoring if some QR codes are lost.
Restore with lost codes is only possible using qr-backup.
Default: enabled
.TP
\f[B]--error-correction \f[BI]CORRECTION\f[B]\f[R]
Sets the error correction level.
Options are L (7%), M (15%), Q (25%), and H (30%).
Default: M (15%)
.TP
\f[B]--filename \f[BI]FILENAME\f[B]\f[R]
Set the restored filename.
Max 32 chars.
Default: same as FILE
.TP
\f[B]--instructions page|cover|both|none\f[R]
Sets how frequently the instructions are printed.
If `cover' or `both' is selected, more verbose instructions will be
printed on the cover page.
Default: page
.TP
\f[B]--note \f[BI]TEXT\f[B]\f[R]
Add a special note to the printout instructions.
Can be anything.
Default: no note
.TP
\f[B]--num-copies \f[BI]NUMBER\f[B]\f[R]
Print multiple copies of each QR code for redundancy.
Default: 1
.TP
\f[B]--output \f[BI]FILENAME\f[B]\f[R], \f[B]-o \f[BI]FILENAME\f[B]\f[R]
Set the output pdf path (redirecting stdout also works).
Default: FILE.qr.pdf
.TP
\f[B]--page \f[BI]WIDTH_POINTS\f[B] \f[BI]HEIGHT_POINTS\f[B]\f[R]
Sets the usable size of the paper on your printer.
This should NOT be 8.5 x 11 -- make sure to include margins.
Default: 500px x 600px
.TP
\f[B]--qr-version \f[BI]VERSION\f[B]\f[R]
Uses QR codes, version VERSION.
Versions range from 1-40.
The bigger the version, the harder to scan but the more data per code.
Default: 10
.TP
\f[B]--scale \f[BI]SCALE\f[B]\f[R]
Scale QR codes so that each small square in the QR code is SCALE x SCALE
pixels.
Default: 5px
.TP
\f[B]--shuffle\f[R], \f[B]--no-shuffle\f[R]
Spread QR codes across pages.
This can help prevent data loss.
Default: yes if erasure coding is enabled (default), no otherwise
.TP
\f[B]--skip-checks\f[R], \f[B]--no-skip-checks\f[R]
Skip erasure code checks, self-restore checks.
Default: not skipped
.SH RESTORE OPTIONS
.TP
\f[B]--code-count-erasure \f[BI]COUNT\f[B]\f[R]
Specify the number of erasure QR codes.
Default: automatic
.TP
\f[B]--code-count-normal \f[BI]COUNT\f[B]\f[R]
Specify the number of normal QR codes.
Default: automatic
.TP
\f[B]--compress\f[R], \f[B]--no-compress\f[R]
Force decompression (on/off).
Default: automatic
.TP
\f[B]--display\f[R], \f[B]--no-display\f[R]
For webcam scanning, (display/don\[cq]t display) a webcam preview.
Default: display
.TP
\f[B]--encrypt \f[BI]PASSPHRASE\f[B]\f[R], \f[B]--no-encrypt\f[R]
Force decryption (on/off) and give the passphrase if decrypting.
Default: automatic
.TP
\f[B]--image-restore\f[R]
Force image-based (scanner) restore.
Default: automatic
.TP
\f[B]--output \f[BI]FILENAME\f[B]\f[R], \f[B]-o \f[BI]FILENAME\f[B]\f[R]
Set the restore file path.
Default: stdout
.TP
\f[B]--sha256 \f[BI]SHA256\f[B]\f[R]
Include a sha256sum to check the file.
Giving the initial part of the sha256sum does a partial check.
Default: no check, prints checksum to stderr
.TP
\f[B]--webcam-restore\f[R]
Force webcam-based restore.
Default: automatic
.SH EXIT VALUES
.TP
\f[B]0\f[R]
Success.
This includes certain self-test failures which sometimes fail by chance.
.TP
\f[B]1\f[R]
Invalid command line option
.TP
\f[B]2\f[R]
File missing or access failed
.TP
\f[B]3\f[R]
Self-test restore failed
.TP
\f[B]4\f[R]
Restore failed
.TP
\f[B]5\f[R]
\f[B]convert\f[R] subcommand failed
.TP
\f[B]6\f[R]
\f[B]zbarimg\f[R] or \f[B]zbarcam\f[R] subcommand failed
.TP
\f[B]7\f[R]
\f[B]gpg\f[R] subcommand failed
.SH BUGS
.PP
Please report any bugs at https://github.com/za3k/qr-backup/issues .
.PP
Sometimes scanned images, including the original PDF, cannot be read
successfully and the restore self-check fails.
This appears to be a bug in \f[B]zbar\f[R].
.PP
On Ubuntu and certain other systems, the default system imagemagick
policy prevents reading or writing PDFs.
Since \f[B]qr-backup\f[R] depends on both, it will fail.
\f[B]qr-backup\f[R] does its best to report this problem clearly.
.PP
It is possible to print barcodes so large or small your webcam or
scanner cannot read them.
Make sure to test your restore process when using non-default settings.
.SH COPYRIGHT
.PP
\f[B]qr-backup\f[R] was written by Zachary Vance, and is released into
the public domain and under CC0
<https://creativecommons.org/share-your-work/public-domain/cc0/>.
The generated PDF includes the DejaVu Sans Mono font, which has a
separate license <https://dejavu-fonts.github.io/License.html>.
.PP
The \f[B]qr-backup\f[R] source code is available at
<https://github.com/za3k/qr-backup>.
.SH AUTHORS
Zachary Vance.
